<template>
  <nav>
    <div>
      <Logo></Logo>
    </div>
    <div id="menu">
      <ul class="menu">
        <li>
          <router-link :to="{name: 'Dashboard'}">Nieuw Traject</router-link>
        </li>
        <li
            v-on:click="toggle('ranking')"
            v-bind:class="{'open' : dropDowns.ranking.open}">
          <a class="menu__link--toggle" href="#">
            Mijn Trajecten <span class="iconify"
                                 data-icon="ls:dropdown"
                                 data-inline="true"></span>
          </a>

          <ul class="dropdown-menu">
            <li>
              <router-link :to="{name: 'Trajectories'}">Alle Trajecten</router-link>
            </li>

            <li>
              <router-link :to="{name: 'Favorite'}">Favoriete Trajecten</router-link>
            </li>
            <li>
              <router-link :to="{name: 'Shared'}">Gedeelde Trajecten</router-link>
            </li>
            <li>
              <router-link :to="{name: 'Accepted'}">Geaccepteerde Trajecten</router-link>
            </li>
          </ul>
        </li>

        <li>
          <router-link :to="{name: 'Login'}" v-if="!user">Inloggen</router-link>
          <button class="login-btn" @click="logout()" v-if="user">
            Uitloggen ({{ user.name }})
          </button>
        </li>
      </ul>
    </div>
  </nav>

</template>

<script>

import Logo from '@/components/UI/atoms/Logo.vue';
import { mapGetters } from 'vuex/dist/vuex';
import { mapActions } from 'vuex';

export default {
  name: 'Nav',
  components: { Logo },

  ready() {
    const self = this;
    window.addEventListener('click', (e) => {
      if (!e.target.parentNode.classList.contains('menu__link--toggle')) {
        self.close();
      }
    }, false);
  },

  data() {
    return {
      dropDowns: {
        ranking: { open: false },
      },
    };
  },
  computed: {
    ...mapGetters('auth', ['user']),
  },
  methods: {
    ...mapActions('auth', ['logOut']),
    /* eslint-disable */
    async logout() {
      try {
        await this.logOut();
        await this.$router.push({ name: 'Login' });
        await window.location.reload(true);
      } catch (error) {
        console.log('error', error);
      }
    },
    toggle(dropdownName) {
      this.dropDowns[dropdownName].open = !this.dropDowns[dropdownName].open;
    },

    close() {
      this.dropDowns.open = false;
    },
  },
};
</script>

<style scoped lang="scss">

nav{
  margin-top: 20px;
  display: flex;
  justify-content: space-between;
  width: 100%;
  border-bottom: 1px solid $custom_blue;

  div{
    padding:0 5%;
  }

  ul{
    list-style: none;
    display: flex;
    justify-content: space-between;

    li{
      padding-left: 30px;

      a{
        text-decoration: none;
        font-family: 'Roboto', sans-serif;
        font-style: normal;
        font-weight: normal;
        font-size: 18px;
        color: $custom_blue;
      }
      a:hover{
        color: $custom_red;
      }
    }
  }
}
.router-link-exact-active{
  color: $custom-green;
}
.menu {
  display: flex;
}

.open .dropdown-menu {
  display: block;
}

.dropdown-menu {
  position: absolute;
  display: none;
  top: 72px;
  padding: 20px;
  border-radius: 6px;
  background-color: #F2F2F2;
  opacity: 0.95;
}
.dropdown-menu li{
  padding: 10px;
}
.login-btn{
  text-decoration: none;
  font-family: 'Roboto', sans-serif;
  font-style: normal;
  font-weight: normal;
  font-size: 18px;
  color: $custom_blue;
  background-color: transparent;
}
.login-btn:hover{
  color: $custom_red;
}

</style>
